import pyscipopt as scip


class NodepruPolicy(scip.Nodepru):
    def __init__(self, verbose=False):
        super().__init__()
        self.number_nodes_pruned = 0
        self.verbose = verbose

    def nodeprune(self):
        depth = self.model.getDepth()
        if depth < 1:
            return {'result': False}
        node = self.model.getCurrentNode()
        prune = node.getPolicyPrune()
        if self.verbose and prune:
            node_number = node.getNumber()
            print(f'Pruned {node_number}')

        if prune:
            self.number_nodes_pruned += 1
        return {'result': prune}
