from pyscipopt import scip


class NodeselBaseline(scip.Nodesel):
    def __init__(self, prune=False):
        super().__init__()
        self.prune = prune

    def handle_pruning(self, selnode, model):
        if self.prune and model.getDepth() >= 0:
            openNodes = model.getOpenNodesData()
            children = openNodes['children']
            assert len(children) == 2
            selnode.setPolicyPrune(False)
            selnode_number = selnode.getNumber()
            children_numbers = [x.getNumber() for x in children]
            node_child_index_prune = 1 - children_numbers.index(selnode_number)
            selnode_sibling = children[node_child_index_prune]
            selnode_sibling.setPolicyPrune(True)


