from evaluation.nodesel_baseline import NodeselBaseline


class NodeselDfs(NodeselBaseline):
    def __init__(self, prune=False):
        super().__init__(prune)

    def nodeselect(self):
        selnode = self.model.getPrioChild()
        if selnode is not None:
            self.handle_pruning(selnode, self.model)
            return {"selnode": selnode}

        selnode = self.model.getPrioSibling()

        if selnode is not None:
            return {"selnode": selnode}

        selnode = self.model.getBestLeaf()

        return {"selnode": selnode}

    def nodecomp(self, node1, node2):
        depth1 = node1.getDepth()
        depth2 = node2.getDepth()

        if depth1 > depth2:
            return -1
        elif depth1 < depth2:
            return 1
        else:
            lowerbound1 = node1.getLowerbound()
            lowerbound2 = node2.getLowerbound()
            if lowerbound1 < lowerbound2:
                return -1
            elif lowerbound1 > lowerbound2:
                return 1
            else:
                return 0